/*-------------------------------------------------------------------------------------------------
Author     : Miro Zelina
Company    : Husky Energy
Description: 
Inputs     : N/A
Test Class : SPCC_ImportPOsControllerTest
History    : mz: 04-June-2018 - Vendors to be identify by SAP ID instead of Vendor Name (W-001063)
             mz: 12-Junw-2018 - aligned formatting, removed dead code
            ---------------------------------------------------------------------------------------------------*/ 
public with sharing class SPCC_ImportPOsController {

public Transient Blob csvFileBody{get;set;}
public String csvAsString{get;set;}
public Integer csvFileSize {get;set;}
public List<String> csvFileLines{get;set;}
public Boolean loadButtonClickedSucc {get;set;}
public Boolean saveButtonClicked {get;set;}
public Boolean fileTooBig {get;set;}
public Set<String> lineItemValuesSet {get;set;}


public static Integer COLUMN_INDEX_PO_NUMBER = 0;
public static Integer COLUMN_INDEX_LI_NUMBER = 1;
public static Integer COLUMN_INDEX_EWR = 2;
public static Integer COLUMN_INDEX_AFE = 3;
public static Integer COLUMN_INDEX_GL_CODE = 4;
public static Integer COLUMN_INDEX_COST_CODE = 5;
public static Integer COLUMN_INDEX_VENDOR = 6;
public static Integer COLUMN_INDEX_VENDOR_ID = 7;
public static Integer COLUMN_INDEX_LI_VALUE = 8;
public static Integer COLUMN_INDEX_LI_SHORT_TEXT = 9;
public static Integer COLUMN_INDEX_DESCRITPION = 10;

public List<ImportPOTicket> poList{get;set;}

    public SPCC_ImportPOsController() {

    csvFileLines = new String[]{};
    poList = new List<ImportPOTicket>();
    loadButtonClickedSucc = false;
    saveButtonClicked = false;
    fileTooBig = false;
    lineItemValuesSet = getLineItemValues();
    }

    
    //Load import file
    public void importCSVfile(){

        List<String> aDataCheck;
        loadButtonClickedSucc = true;
        saveButtonClicked = false;
        fileTooBig = false;

        try{

            poList = new List<ImportPOTicket>();
            csvAsString = blobToString(csvFileBody);  //mz: 23-Feb-18 fix UTF-8
            csvFileLines = csvAsString.split('\n'); 

            Set<String> poNumberSet = new Set<String>();
            Set<String> poKeyIdSet = new Set<String>();
            Set<String> ewrIdSet = new Set<String>();
            Set<String> afeIdSet = new Set<String>();
            Set<String> glIdSet = new Set<String>();
            Set<String> costCodeIdSet = new Set<String>();
            Set<String> vendorIdSet = new Set<String>(); 
            Set<String> pLiIdSet = new Set<String>(); 
            Set<String> poDuplLiCheck = new Set<String>();
            Set<String> poDuplKeyCheck = new Set<String>();

            if(csvFileLines.size()>501){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'Maximum size is 500 rows. Please make sure input csv file is correct.');
                ApexPages.addMessage(errorMessage); 
                loadButtonClickedSucc = false;
                fileTooBig = true;            
            }

            CheckCollumnIndexes(csvFileLines[0]);

            for (Integer i=1;i<Math.min(csvFileLines.size(), 501);i++){
                 aDataCheck = csvFileLines[i].replace('\r','').split(',');

                if(aDataCheck.size() > 0 && !fileTooBig){
                    ImportPOTicket poWrapperObj = new ImportPOTicket(csvFileLines[i],
                                                                     poNumberSet,
                                                                     poKeyIdSet, 
                                                                     ewrIdSet, 
                                                                     afeIdSet,
                                                                     glIdSet,
                                                                     costCodeIdSet,
                                                                     vendorIdSet,
                                                                     pLiIdSet,
                                                                     poDuplLiCheck,
                                                                     poDuplKeyCheck,
                                                                     lineItemValuesSet);

                    poWrapperObj.rowNum = i + 1;
                    poList.add(poWrapperObj);
                }
            } 


        //prepare PO Number map
        List<SPCC_Purchase_Order__c> poNumberList = [SELECT Id, Name, Purchase_Order_Number__c, Key__c 
                                                     FROM SPCC_Purchase_Order__c 
                                                     WHERE Purchase_Order_Number__c IN :poNumberSet 
                                                     LIMIT 5000];
                                                     
        Map<String, SPCC_Purchase_Order__c> poNumberMap = new Map<String, SPCC_Purchase_Order__c>(); 
        for (SPCC_Purchase_Order__c poRec : poNumberList){
                poNumberMap.put(poRec.Purchase_Order_Number__c, poRec);
        }
        
        //prepare PO Key map
        List<SPCC_Purchase_Order__c> poKeyList = [SELECT Id, Name, Purchase_Order_Number__c, Key__c 
                                                  FROM SPCC_Purchase_Order__c 
                                                  WHERE Key__c IN :poKeyIdSet 
                                                  LIMIT 5000];
                                                  
        Map<String, SPCC_Purchase_Order__c> poMap = new Map<String, SPCC_Purchase_Order__c>(); 
        for (SPCC_Purchase_Order__c poRec : poKeyList){
                poMap.put(poRec.Key__c.toUpperCase(), poRec);
        }
            
        //prepare Line Item map
        List<SPCC_Line_Item__c> liList = [SELECT Id, Name, Purchase_Order__c, Purchase_Order__r.Name,
                                                 Cost_Element__c, Cost_Element__r.GL_Number__c, Item__c, Key__c
                                          FROM SPCC_Line_Item__c 
                                          WHERE Key__c IN :pLiIdSet 
                                          LIMIT 5000];
                                          
        Map<String, SPCC_Line_Item__c> liMap = new Map<String, SPCC_Line_Item__c>(); 
        for (SPCC_Line_Item__c liRec : liList){
                liMap.put(liRec.Key__c.toUpperCase(), liRec);
        }

        //prepare EWR map
        List<SPCC_Engineering_Work_Request__c> ewrList = [SELECT Id, Name 
                                                          FROM SPCC_Engineering_Work_Request__c 
                                                          WHERE Name IN :ewrIdSet 
                                                          LIMIT 5000];
                                                          
        Map<String, SPCC_Engineering_Work_Request__c> ewrMap = new Map<String, SPCC_Engineering_Work_Request__c>(); 
        for (SPCC_Engineering_Work_Request__c ewrRec : ewrList){
                ewrMap.put(ewrRec.Name, ewrRec);
        }

        //prepare AFE map
        List<SPCC_Authorization_for_Expenditure__c> afeList = [SELECT Id, Name, Engineering_Work_Request__r.Name 
                                                               FROM SPCC_Authorization_for_Expenditure__c 
                                                               WHERE Name IN :afeIdSet 
                                                               LIMIT 5000];
                                                               
        Map<String, SPCC_Authorization_for_Expenditure__c> afeMap = new Map<String, SPCC_Authorization_for_Expenditure__c>();
        Map<String, SPCC_Authorization_for_Expenditure__c> afeToEwrMap = new Map<String, SPCC_Authorization_for_Expenditure__c>();
        for (SPCC_Authorization_for_Expenditure__c afeRec : afeList){
                afeMap.put(afeRec.Name.toUpperCase(), afeRec);
                afeToEwrMap.put(afeRec.Name.toUpperCase() + '-' + afeRec.Engineering_Work_Request__r.Name, afeRec);
        }

        //prepare GL code map
        List<SPCC_Cost_Element__c> glList = [SELECT Id, GL_Number__c, AFE__r.Name 
                                             FROM SPCC_Cost_Element__c 
                                             WHERE GL_AFE__c IN :glIdSet
                                             LIMIT 5000];
                                             
        Map<String, SPCC_Cost_Element__c> glMap = new Map<String, SPCC_Cost_Element__c>();
        Map<String, SPCC_Cost_Element__c> glToAfeMap = new Map<String, SPCC_Cost_Element__c>();  
        for (SPCC_Cost_Element__c glRec : glList){
                glMap.put(glRec.GL_Number__c, glRec);
                glToAfeMap.put(glRec.GL_Number__c + '-' + glRec.AFE__r.Name.toUpperCase(), glRec);
        } 


        /* commented - cost codes not in use yet
        //prepare cost code map 
        List<SPCC_Cost_Code__c> costCodeList = [SELECT Id, Cost_Code_Number__c, GL_Account__r.GL_Number__c, GL_Account__r.AFE__r.Name 
                                                               FROM SPCC_Cost_Code__c 
                                                               WHERE CostCode_GL_AFE__c IN :costCodeIdSet 
                                                               LIMIT 5000];
                                                               
        Map<String, SPCC_Cost_Code__c> costCodeMap = new Map<String, SPCC_Cost_Code__c>();
        Map<String, SPCC_Cost_Code__c> costCodeToGlCodeMap = new Map<String, SPCC_Cost_Code__c>();  
        for(SPCC_Cost_Code__c costCodeRec : costCodeList)            
            {
                costCodeMap.put(costCodeRec.Cost_Code_Number__c, costCodeRec);
                costCodeToGlCodeMap.put(costCodeRec.Cost_Code_Number__c + '-' + costCodeRec.GL_Account__r.GL_Number__c + '-' + costCodeRec.GL_Account__r.AFE__r.Name.toUpperCase(), costCodeRec);
            }
        */

        //Prepare Vendor Account Assignment to EWR map    
        List<SPCC_Vendor_Account_Assignment__c> vendorList = [SELECT Id, Vendor_Account__c, Vendor_Account__r.Name, 
                                                                     Vendor_Account__r.SAP_ID__c, Engineering_Work_Request__r.Name 
                                                              FROM SPCC_Vendor_Account_Assignment__c 
                                                              WHERE Vendor_Account__r.SAP_ID__c IN :vendorIdSet 
                                                              AND Engineering_Work_Request__r.Name IN :ewrIdSet
                                                              LIMIT 5000];

        Map<String, SPCC_Vendor_Account_Assignment__c> vendorToEWRMap = new Map<String, SPCC_Vendor_Account_Assignment__c>();  
        for (SPCC_Vendor_Account_Assignment__c vendorRec : vendorList){
                vendorToEWRMap.put(vendorRec.Vendor_Account__r.SAP_ID__c.toUpperCase() + '-' + vendorRec.Engineering_Work_Request__r.Name, vendorRec);
                System.Debug('vendorToEWRMap: ' + vendorToEWRMap);
        }  

        //Prepare Account Map
        List<Account> allVendorsList = [SELECT Id, Name, SAP_ID__c 
                                        FROM Account 
                                        WHERE SAP_ID__c IN :vendorIdSet
                                        AND RecordType.DeveloperName = 'SPCC_Vendor'
                                        LIMIT 5000]; 
                                        
        Map<String, Account> allVendorMap = new Map<String, Account>();  
        for (Account a : allVendorsList){
            allVendorMap.put(a.SAP_ID__c.toUpperCase(), a);
        }                            
   

        Set<String> poNumDuplCheck = new Set<String>();
        Map<String, String> duplicateEntryCheckMap = new Map<String, String>();
        
        for (ImportPOTicket ticketRec :poList){
                
                //try to find PO Number
                String poNumber =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_PO_NUMBER); 
                String liNumber =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_LI_NUMBER);
                String ewrNumber =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_EWR);
                String afeNumber =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_AFE); 
                String vendorName =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_VENDOR);
                String vendorId =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_VENDOR_ID);
                
                afeNumber = afeNumber.toUpperCase();
                vendorName = vendorName.toUpperCase();

                if(!ticketRec.requiredFieldsMissing.contains('ponumber')) {
                    
                    if (poNumber.length() < 10){
                        
                        while (poNumber.length() < 10){
                            poNumber = '0' + poNumber;
                        }  
                    }        
                    
                    //check for existing po number in sfdc
                    if(poNumberMap.containsKey(poNumber)){
                        ticketRec.existingPO = true;
                    }
                    
                    else {
                        ticketRec.existingPO = false;
                    }

                    //check for po entry (for not exisitng PO in sfdc) with different key fields
                    if(!poNumDuplCheck.add(poNumber) && (duplicateEntryCheckMap.get(poNumber) <> (ewrNumber + '-' + afeNumber + '-' + vendorId)) && ticketRec.existingPO == false){
                        ticketRec.isError = true;
                        ticketRec.errorMessage += 'Some of the key fields on this PO does not match with previous PO entry key fields in import field. ';
                    }
                    else {
                        poNumDuplCheck.add(poNumber);
                        duplicateEntryCheckMap.put(poNumber, ewrNumber + '-' + afeNumber + '-' + vendorId); 
                    }

                    //check for po entry (for exisitng PO in sfdc) with different key fields
                    if (poNumberMap.containsKey(poNumber) && (poNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorId <> poNumberMap.get(poNumber).Key__c.toUpperCase()) && ticketRec.existingPO == true){
                       ticketRec.isError = true;
                       ticketRec.errorMessage += 'Some of the key fields are different for the PO to be imported. Please check existing PO in system and correct PO entry in import file. Key fields: EWR Number, AFE Number and Vendor name.' + '<br/>'; 
                    }
                    
                    //if key fields for PO match - setting properties for vf page
                    if(poMap.containsKey(poNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorId)){
                        ticketRec.poId = poMap.get(poNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorId).id;
                        ticketRec.poName = poMap.get(poNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorId).Name;
                    }
                    else 
                    {
                        ticketRec.po.Name = poNumber;
                    }
                }
                
                //try to find Line Item
                if (liNumber.length() < 4){
                        
                    while (liNumber.length() < 4){
                        
                        liNumber = '0' + liNumber;
                    }
                }
                
                if (liMap.containsKey(poNumber + '-' + liNumber)){
                    
                    ticketRec.lineItem.Id = liMap.get(poNumber + '-' + liNumber).Id;
                }
                

                //try to find EWR Number              
                if (!ticketRec.requiredFieldsMissing.contains('ewrnumber') && !ticketRec.isError) {
                    if (ewrMap.containsKey(ewrNumber)){
                        ticketRec.po.Engineering_Work_Request__c = ewrMap.get(ewrNumber).id;
                    }   
                    else{
                        ticketRec.isError = true;
                        ticketRec.errorMessage +='Unable to find EWR: ' + '<b>' + ewrNumber + '</b>' + '<br/>';
                    } 
                }


                //try to find AFE Number
                if (!ticketRec.requiredFieldsMissing.contains('afenumber') && !ticketRec.isError) {
                    if (afeMap.containsKey(afeNumber)){
                        if (afeToEwrMap.containsKey(afeNumber + '-' + ewrNumber)){
                            ticketRec.po.Authorization_for_Expenditure__c = afeToEwrMap.get(afeNumber + '-' + ewrNumber).id;
                        }
                        else{
                            ticketRec.isError = true;
                            ticketRec.errorMessage +='No such combination of AFE / EWR in the system: ' + '<b>' + afeNumber + '</b>' + ' / ' + '<b>' + ewrNumber + '</b>' + '<br/>';
                        }
                    }
                    else{
                        ticketRec.isError = true;
                        ticketRec.errorMessage +='Unable to find AFE: ' + '<b>' + afeNumber + '</b>' + '<br/>';
                    }
                }   


                //try to find GL Code and Cost Code
                String glCode =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_GL_CODE); 
                String costCode =  GetStringValue(ticketRec.RecordData,COLUMN_INDEX_COST_CODE); 

                if (!ticketRec.requiredFieldsMissing.contains('glandcc') && !ticketRec.isError) {
                    if (!ticketRec.requiredFieldsMissing.contains('_gl_')) {
                        if (glMap.containsKey(glCode)){
                            if (glToAfeMap.containsKey(glCode + '-' + afeNumber)){
                                ticketRec.lineItem.Cost_Element__c = glToAfeMap.get(glCode + '-' + afeNumber).id;
                            }
                            else{
                                ticketRec.isError = true;
                                ticketRec.errorMessage +='No such combination of GL Code / AFE in the system: ' + '<b>' + glCode + '</b>' + ' / ' + '<b>' + afeNumber + '</b>' + '<br/>';
                            }
                        } 


                        //creating Misc GL record if it's not Standar GL Code
                        else  {

                            if (glCode.length() == 7 && glCode.isNumeric()){  //do the GL Code format validation

                                //populate misc GL Code fields
                                ticketRec.costElement.AFE__c = afeToEwrMap.get(afeNumber + '-' + ewrNumber).id;
                                ticketRec.costElement.Category__c = SPCC_Utilities.GL_CODE_CATEGORY_OTHER;
                                ticketRec.costElement.GL_Number__c = glCode;
                                ticketRec.costElement.Original_Auth_Amt__c = 0.00;
                                ticketRec.costElement.Trend__c = 0.00;
                                ticketRec.costElement.Cost_Element_Ext__c = afeNumber + '-' + glCode;
                                ticketRec.miscGL = true;
                                
                            }
                            else {
                                ticketRec.isError = true;
                                ticketRec.errorMessage +='Wrong format for G/L Account ' + '<b>' + glCode + '</b>' + '. GL Number should be 7 digits long and numeric.' + '<br/>';
                            }
                        }
                    }
                    //not cost codes in the system yet:
                    /*
                    if (!ticketRec.requiredFieldsMissing.contains('_cc_')) {
                        if (costCodeMap.containsKey(costCode)){
                            if (costCodeToGlCodeMap.containsKey(costCode + '-' + glCode + '-' + afeNumber)){
                                ticketRec.po.Cost_Code__c = costCodeToGlCodeMap.get(costCode + '-' + glCode + '-' + afeNumber).id;
                            }
                            else{
                                ticketRec.isError = true;
                                ticketRec.errorMessage +='No such combination of Cost Code / GL Code in the system: ' + '<b>' + costCode + '</b>' + ' / ' + '<b>' + glCode + '</b>' + '<br/>';
                            }
                        }   
                        else{
                            ticketRec.isError = true;
                            ticketRec.errorMessage +='Unable to find Cost Code: ' + costCode + '<br/>';
                        }
                    } */
                }

                //try to find Vendor
                if (!ticketRec.requiredFieldsMissing.contains('vendor') && !ticketRec.isError) {
                    System.Debug('dbg_vendorId' + vendorId);
                    if (allVendorMap.containsKey(vendorId)){
                        if (vendorToEWRMap.containsKey(vendorId + '-' + ewrNumber)) {
                            ticketRec.po.Vendor_Account__c = vendorToEWRMap.get(vendorId + '-' + ewrNumber).Vendor_Account__c;
                        }
                        else{
                            ticketRec.isInfo = true;
                            ticketRec.po.Vendor_Account__c = allVendorMap.get(vendorId).Id;
                            ticketRec.vaa.Vendor_Account__c = allVendorMap.get(vendorId).Id;
                            ticketRec.vaa.Engineering_Work_Request__c = ewrMap.get(ewrNumber).id;
                            ticketRec.errorMessage +='Vendor Account ' + '<b>' + vendorName + '(' + vendorId +  ')' + '</b>' + ' will be assigned to ' + '<b>' + ewrNumber + '</b>' + ' Project.'  + '<br/>';
                        }
                    }
                    else {
                        ticketRec.isError = true;
                        ticketRec.errorMessage +='Unable to find Vendor: ' + '<b>' +  vendorName + ' (' + vendorId +  ') ' + '</b>' + '<br/>';
                    } 
                }     
        }

            for (ImportPOTicket ticketRec : poList){

                if (ticketRec.isError){
                    loadButtonClickedSucc = false;
                    break;
                }
                else{
                    loadButtonClickedSucc = true;
                }
            }
            
            csvFileBody = null;
        }    

        catch (Exception e){   
            loadButtonClickedSucc = false;
            ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'An error has occured while importing data. Please make sure input csv file is correct. ' + e.getMessage());
            ApexPages.addMessage(errorMessage);
            system.debug(e);
            System.Debug('debug_ ' +e.getLineNumber());
        }  
    }

    //Save import file
    public void importPOList(){

        List<SPCC_Purchase_Order__c> poTicketList = new List<SPCC_Purchase_Order__c>();
        List<SPCC_Purchase_Order__c> poTicketReversedList = new List<SPCC_Purchase_Order__c>();
        List<SPCC_Purchase_Order__c> uniquePoTicketList = new List<SPCC_Purchase_Order__c>();
        
        List<ImportPOTicket> updatedPOTicketList = new List<ImportPOTicket>();
        List<ImportPOTicket> updatedPOTicketReversedList = new List<ImportPOTicket>();
        List<ImportPOTicket> uniqueUpdatedPOTicketList = new List<ImportPOTicket>();

        List<ImportPOTicket> costEleToInsertTicket = new List<ImportPOTicket>();
        List<SPCC_Cost_Element__c> costEleToInsertList = new List<SPCC_Cost_Element__c>();

        List<SPCC_Cost_Element__c> costEleToDeleteList = new List<SPCC_Cost_Element__c>();
        Set<SPCC_Cost_Element__c> costEleToDeleteSet = new Set<SPCC_Cost_Element__c>();
        
        Set<SPCC_Line_Item__c> liToInsertSet = new Set<SPCC_Line_Item__c>();

        Set<SPCC_Vendor_Account_Assignment__c> vaaToInsert = new Set<SPCC_Vendor_Account_Assignment__c>();

        saveButtonClicked = true;

      try
        {
            //create set of Misc GL Codes
            for (ImportPOTicket ticketRec :poList){

                if (ticketRec <> null && ticketRec.isError <> true && ticketRec.costElement <> null && ticketRec.miscGL == true){
                        costEleToInsertList.add(ticketRec.costElement); //List Of Cos Elements records
                        costEleToInsertTicket.add(ticketRec); //Full List of wrapped GL records
                }
            }


            //Insert Misc Gl Codes
            Set<Id> succGLSetId = new Set<Id>();
            Integer succesfullyInsertedGLs = 0;
            Set<String> unucessfullyInsertedGlCodePONumbersSet = new Set<String>();
            Map<String, String> errMsgForGLcode = new Map<String, String>();
            Map<String, String> glExtIdToIdMap = new Map<String, String>();

            if (!costEleToInsertList.isEmpty()) {   

                try {
                    Set<SPCC_Cost_Element__c> costEleToInsertSet = new Set<SPCC_Cost_Element__c>();
                    for (SPCC_Cost_Element__c costEle : costEleToInsertList){
                        
                       costEleToInsertSet.add(costEle); 
                    }
                    
                    List<SPCC_Cost_Element__c> uniqueCostEleToInsertList = new List<SPCC_Cost_Element__c>(costEleToInsertSet);
                    
                    List<Database.UpsertResult> insertGLResults = Database.upsert(uniqueCostEleToInsertList, false);

                    for (Integer i=0; i<insertGLResults.size(); i++){    

                        if (insertGLResults.get(i).isSuccess()) {

                            succesfullyInsertedGLs++;
                            succGLSetId.add(insertGLResults[i].getId());
                        }

                        else {
                                //Create Map of error message per GL Code
                                for (Database.Error error : insertGLResults.get(i).getErrors()){

                                    String failedDML = error.getMessage();
                                    errMsgForGLcode.put(costEleToInsertList[i].GL_Number__c + '-' + costEleToInsertList[i].AFE__c, error.getMessage());
                                    unucessfullyInsertedGlCodePONumbersSet.add(costEleToInsertTicket[i].po.Purchase_Order_Number__c);   
                                }
                        }
                    } 
                } 
                catch (DmlException ex) {
                    System.Debug('Following errors have occoured during saving records: ' + ex.getMessage());
                }
            }


            for (ImportPOTicket ticket : updatedPOTicketList){

                if (ticket.miscGL && errMsgForGLcode.containsKey(ticket.costElement.GL_Number__c + '-' + ticket.costElement.AFE__c)){

                    ticket.errorMessage = errMsgForGLcode.get(ticket.costElement.GL_Number__c + '-' + ticket.costElement.AFE__c) + '<br/>';
                    ticket.isError = true;
                }
            }


            //looping thru all POs and setting error flag for PO's for which GL Code was not inserted because of error
            for (ImportPOTicket ticketRec :poList){
                   
                if (unucessfullyInsertedGlCodePONumbersSet.contains(ticketRec.po.Purchase_Order_Number__c)){
                    ticketRec.isError = true;
                    ticketRec.errorMessage = errMsgForGLcode.get(ticketRec.costElement.GL_Number__c + '-' + ticketRec.costElement.AFE__c) + '<br/>';  
                }

                
                if (ticketRec <> null && ticketRec.isError <> true){

                    //If there is not error update Cost Element lookup on PO with related Misc GL 
                    if (ticketRec.costElement <> null && ticketRec.miscGL == true && ticketRec.costElement.Id <> null){
                        glExtIdToIdMap.put(ticketRec.costElement.Cost_Element_Ext__c, ticketRec.costElement.Id); //mz: 3-Apr-18 fix W-000987
                    }

                    ticketRec.errorMessage = '';
                    ticketRec.isInfo = false;
                    ticketRec.isWarning = false; 
                    poTicketList.add(ticketRec.po);
                    updatedPOTicketList.add(ticketRec); 
                }
            }
            
            //revert list of make it unique - to upsert values of last entry in imported file
            for(Integer i = updatedPOTicketList.size() - 1; i >= 0; i--){
                updatedPOTicketReversedList.add(updatedPOTicketList[i]);
            }
            
            Set<String> poKeySet = new Set<String>();
            for (ImportPOTicket ticket : updatedPOTicketReversedList){
                
                if(!poKeySet.add(ticket.poKey)){
                    //skip duplicate PO
                }
                else {
                    
                    uniquePoTicketList.add(ticket.po);
                    uniqueUpdatedPOTicketList.add(ticket);
                }
            }

        
            //Finally Upser of PO's (with Cost element filled)
            Schema.SObjectField poExtId = SPCC_Purchase_Order__c.Fields.Purchase_Order_Number__c;
            Database.UpsertResult[] upsertResults = Database.upsert(uniquePoTicketList, poExtId, false);

            Set<Id> succPOSetId = new Set<Id>();
            Map<String, ImportPOTicket> succPoMap = new Map<String, ImportPOTicket>();
            Map<String, String> errMsgForPO = new Map<String, String>();
            Integer importedSuccessfully = 0;
            
            for (Integer i=0;i<upsertResults.size();i++){

                //set error flag if PO's was not inserted beacuse of error
                if (!upsertResults.get(i).isSuccess()){

                    //Create set of GL codes to be deleted for the Po's which were not inserted
                    if(uniqueUpdatedPOTicketList[i].miscGL == true){

                        costEleToDeleteSet.add(uniqueUpdatedPOTicketList[i].costElement);
                    }


                    // DML operation failed
                    uniqueUpdatedPOTicketList[i].isError = true;
                    for(Database.Error error : upsertResults.get(i).getErrors()){
                        String failedDML = error.getMessage();
                        errMsgForPO.put(uniqueUpdatedPOTicketList[i].poKey, failedDML);
                    }
                }
                   
                else{
                    importedSuccessfully++;
                    succPOSetId.add(upsertResults.get(i).getId());
                    succPoMap.put(uniqueUpdatedPOTicketList[i].po.Purchase_Order_Number__c , uniqueUpdatedPOTicketList[i]);

                    //fill list of VAA to be inserted
                    if (uniqueUpdatedPOTicketList[i].po.Vendor_Account__c <> null && 
                        uniqueUpdatedPOTicketList[i].vaa.Engineering_Work_Request__c <> null && 
                        uniqueUpdatedPOTicketList[i].vaa.Vendor_Account__c <> null){

                        vaaToInsert.add(new SPCC_Vendor_Account_Assignment__c(Engineering_Work_Request__c = uniqueUpdatedPOTicketList[i].vaa.Engineering_Work_Request__c,
                                                                               Vendor_Account__c = uniqueUpdatedPOTicketList[i].vaa.Vendor_Account__c));
                    }
                }
            }  
            

            //Delete GL Codes where related PO's were not created
            if (!costEleToDeleteSet.isEmpty()){
                costEleToDeleteList = new List<SPCC_Cost_Element__c>(costEleToDeleteSet);
                Delete costEleToDeleteList;
            }

            
            //fill the list of Line Items to be inserted
            List<ImportPOTicket> poTicketForLiToBeInserted = new List<ImportPOTicket>();
            for(ImportPOTicket ticketRec :updatedPOTicketList){
                
                if (succPoMap.containsKey(ticketRec.po.Purchase_Order_Number__c)){
                    ticketRec.lineItem.Purchase_Order__c = succPoMap.get(ticketRec.po.Purchase_Order_Number__c).po.Id;
                    
                    if (ticketRec.miscGL == true){ //mz: 3-Apr-18 fix W-000987
                        ticketRec.lineItem.Cost_Element__c = glExtIdToIdMap.get(ticketRec.costElement.Cost_Element_Ext__c);
                    }
                    liToInsertSet.add(ticketRec.lineItem);
                    poTicketForLiToBeInserted.add(ticketRec);
                }
            }
            
            
            //Line Items upsert
            Integer succesfullyUpsertedLIs = 0;
            Map<String, String> errMsgForLI = new Map<String, String>();
            if (!liToInsertSet.IsEmpty()){
                
                List<SPCC_Line_Item__c> liToInsertList = new List<SPCC_Line_Item__c>(liToInsertSet);
                
                try {
                    List<Database.UpsertResult> upsertLIResults = Database.upsert(liToInsertList, false);

                    for (Integer i=0; i<upsertLIResults.size(); i++){    

                        if (upsertLIResults.get(i).isSuccess()) {

                            succesfullyUpsertedLIs++;
                        }

                        else {
                                //Create Map of error message per GL Code
                                for (Database.Error error : upsertLIResults.get(i).getErrors()){

                                    String failedDML = error.getMessage();
                                    errMsgForLI.put(poTicketForLiToBeInserted[i].po.Purchase_Order_Number__c + '-' + poTicketForLiToBeInserted[i].lineItem.Item__c, error.getMessage());
                                }
                        }
                    } 
                } 
                catch (DmlException ex) {
                    System.Debug('Following errors have occoured during saving records: ' + ex.getMessage());
                }
            }
            
            
            
            Integer succesfullyInsertedVAAs = 0;
            if (!vaaToInsert.isEmpty()){   
                //convert VAA set to List for insert
                List<SPCC_Vendor_Account_Assignment__c> vaaToInsertList = new List<SPCC_Vendor_Account_Assignment__c>(vaaToInsert);
                List<Database.SaveResult> insertVAAResults = Database.insert(vaaToInsertList, false);
                
                for (Database.SaveResult sr : insertVAAResults){

                    if (sr.isSuccess()) {

                        succesfullyInsertedVAAs++;
                    }
                }
            }
            
            //set error message for LI upsert
            //set po id -> to display relevant info on vf page (status icons)
            for (ImportPOTicket ticketRec :poList){
                
                if (errMsgForPO.containsKey(ticketRec.poKey)){
                    ticketRec.isError = true;
                    ticketRec.errorMessage += errMsgForPO.get(ticketRec.poKey) + '<br/>';
                }
                
                if (errMsgForLI.containsKey(ticketRec.po.Purchase_Order_Number__c + '-' + ticketRec.lineItem.Item__c)){
                    ticketRec.isError = true;
                    ticketRec.errorMessage += errMsgForLI.get(ticketRec.po.Purchase_Order_Number__c + '-' + ticketRec.lineItem.Item__c) + '<br/>';
                }
                
                if (succPoMap.containsKey(ticketRec.po.Purchase_Order_Number__c) && ticketRec.isError == false){
                    ticketRec.po.Id = succPoMap.get(ticketRec.po.Purchase_Order_Number__c).po.Id;
                }
            }

            //Diplay result messages
            if(importedSuccessfully == 0){
                ApexPages.Message unsuccessMessage = new ApexPages.Message(ApexPages.severity.Error,'Imported Purchase Orders: ' + '<b>' + importedSuccessfully + '</b>');
                ApexPages.addMessage(unsuccessMessage);  

            }

            if (importedSuccessfully > 0){
                ApexPages.Message successMessage = new ApexPages.Message(ApexPages.severity.Confirm,'Imported Purchase Orders: ' + '<b>' + importedSuccessfully + '</b>');
                ApexPages.addMessage(successMessage); 
            } 
            
            if (succesfullyUpsertedLIs > 0){
                ApexPages.Message successMessage = new ApexPages.Message(ApexPages.severity.Confirm,'Imported Line Items: ' + '<b>' + succesfullyUpsertedLIs + '</b>');
                ApexPages.addMessage(successMessage); 
            } 

            if(succesfullyInsertedVAAs > 0){
                ApexPages.Message successMessage2 = new ApexPages.Message(ApexPages.severity.Confirm,'Number of succesfully assigned Vendor Accounts: ' + '<b>' + succesfullyInsertedVAAs + '</b>');           
                ApexPages.addMessage(successMessage2);     
            }
        }
        
        catch (Exception e)
        {
            //Disaply error messages
            ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'An error has occured while saving data: ' + e.getMessage() + ' Line: '+ e.getLineNumber());  
            ApexPages.addMessage(errorMessage);
        }    
    }
    

    //get column index method
    public static void CheckCollumnIndexes(String pCsvHeaderLine)
    {

        String[] pCsvRecordHeader = pCsvHeaderLine.replace('\r','').split(',');
        
        if (pCsvRecordHeader.Size() <> 11){
            ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> Import file needs to have 11 columns ("PO Number", "Line Item Number", "EWR", "AFE", "GL Code", "Cost Code", "Vendor","Vendor ID", "Line Item Value", "Line Item Short Text", "PO Description") ');
            ApexPages.addMessage(errorMessage);
        }
        
        else{
            
            //check for correct name of first column
            if (pCsvRecordHeader[0] != 'PO Number'){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 1st column\'s header has to be " <b> PO Number </b> " (case sensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[1].trim().tolowercase() != 'Line Item Number'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 2nd column\'s header has to be " <b> Line Item Number </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[2].trim().tolowercase() != 'EWR'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 3rd column\'s header has to be " <b>EWR</b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
             if (pCsvRecordHeader[3].trim().tolowercase() != 'AFE'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 4th column\'s header has to be " <b> AFE </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[4].trim().tolowercase() != 'GL Code'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 5th column\'s header has to be " <b> GL Code </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[5].trim().tolowercase() != 'Cost Code'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 6th column\'s header has to be " <b> Cost Code </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[6].trim().tolowercase() != 'Vendor'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 7th column\'s header has to be " <b> Vendor </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[7].trim().tolowercase() != 'Vendor ID'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 8th column\'s header has to be " <b> Vendor ID </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[8].trim().tolowercase() != 'Line Item Value'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 9th column\'s header has to be " <b> Line Item Value </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[9].trim().tolowercase() != 'Line Item Short Text'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> 10th column\'s header has to be " <b> Line Item Short Text </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
            
            if (pCsvRecordHeader[10].trim().tolowercase() != 'PO Description'.tolowercase()){
                ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> Last column\'s header has to be " <b> PO Description </b> " (case insensitive). ');
                ApexPages.addMessage(errorMessage);
            }
        }
    }


    //Parse string values
    public static String GetStringValue(String[] pCsvRecordData, Integer pCollumnIndex){
        
        if (pCsvRecordData.size()<=pCollumnIndex || pCollumnIndex == -1){
            return null;
        }
        return pCsvRecordData[pCollumnIndex].trim();
    }

    //Parse decimal values
    public static Decimal GetDecimalValue(String[] pCsvRecordData, Integer pCollumnIndex){
        if (pCsvRecordData.size()<=pCollumnIndex  || 
            pCollumnIndex == -1 || 
            pCsvRecordData[pCollumnIndex] == null || 
            pCsvRecordData[pCollumnIndex] == ''){
            return null;
        }
        return Decimal.valueOf(pCsvRecordData[pCollumnIndex]);
    }
    
    public static Set<String> getLineItemValues() {
        
    List<Schema.PicklistEntry> lineItemValuesList = SPCC_Line_Item__c.Item__c.getDescribe().getPicklistValues();
    Set<String> livSet = new Set<String>();
    
        if (!lineItemValuesList.isEmpty()){
        
            for(Schema.PicklistEntry ple : lineItemValuesList){
        
                livSet.add(ple.getValue());
            }
        }
        return livSet;
    }
    
    
    public static String blobToString(Blob input) {
        
        String hex = EncodingUtil.convertToHex(input);
        
        if (hex.substringBefore('2c') != 'efbbbf504f204e756d626572' && hex.substringBefore('2c') != '504f204e756d626572'){
            ApexPages.Message errorMessage = new ApexPages.Message(ApexPages.severity.ERROR,'<b> Import file error: </b> First column\'s header has to be " <b> PO Number </b> " (case sensitive). ');
            ApexPages.addMessage(errorMessage);
        }
        
        if (hex.startsWith('efbbbf')){
            String bomStringInHex = hex.substringBefore('504f204e756d626572'); //"PO Number" in hex
            hex = hex.removeStartIgnoreCase(bomStringInHex);
        }

        final Integer bytesCount = hex.length() >> 1;
        String[] bytes = new String[bytesCount];
  
        for(Integer i = 0; i < bytesCount; ++i){
                bytes[i] =  hex.mid(i << 1, 2);
        }
        return EncodingUtil.urlDecode('%' + String.join(bytes, '%'), 'UTF-8');
    }
    
    
    public static List<String> handleDoubleQuotes(String line) {

	// replace instances where a double quote begins and ends a field containing a comma
	line = line.replaceAll(',"',',DBLQT').replaceall('",','DBLQT,');
	//replace double qote at the end of the line
	line = line.replaceAll('"\r','DBLQT\r');
	// now replace all remaining double quotes - we do this so that we can reconstruct
	// fields with commas inside assuming they begin and end with a double quote
	// we are not handling cases if field starts or ends with double qoute and there is not matching double quote
	// at the start of end of the field

    // check for blank CSV lines (only commas)
    System.Debug('dbg_line ' + line);		
    		
    		List<String> fields = line.split(',');	
    		List<String> cleanFields = new List<String>();

    		String compositeField;
    		Boolean makeCompositeField = false;
    		for(String field : fields) {
    			if (field.startsWith('DBLQT') && field.endsWith('DBLQT')) {
    				cleanFields.add(field.replaceAll('DBLQT','"'));
    			} 
    			else if (field.startsWith('DBLQT')) {
    				makeCompositeField = true;
    				compositeField = field;
    			} 
    			else if (field.endsWith('DBLQT')) {
    				compositeField += ',' + field;
    				cleanFields.add(compositeField.replaceAll('DBLQT','"'));
    				makeCompositeField = false;
    			}
    			else if (makeCompositeField) {
    				compositeField +=  ',' + field;
    			}
    			else {
    				cleanFields.add(field.replaceAll('DBLQT','"'));
    			}
    		}
    		
    		//handling double quotes at the end of the line
            if (line.contains('DBLQT\r')){
                cleanFields.add(line.substringAfterLast(',DBLQT').replace('DBLQT\r','\r'));
                system.debug('line ' + line);
            }
    	    return cleanFields;		
    }
    

    //wrapper class
    public class ImportPOTicket{

        public SPCC_Purchase_Order__c po {get; set;}
        public SPCC_Vendor_Account_Assignment__c vaa {get; set;}
        public SPCC_Cost_Element__c costElement {get; set;}
        public SPCC_Line_Item__c lineItem {get; set;}
        public Boolean isError {get; private set;}
        public Boolean isWarning {get; private set;}
        public Boolean isInfo {get;  private set;}
        public Boolean miscGL {get; private set;}
        public Boolean existingPO {get; set;}
        public Integer rowNum {get; set;}
        public String errorMessage {get; set;}
        public String requiredFieldsMissing {get; private set;}
        public String poId {get; set;}
        public String VendorId {get; set;}
        public String poName {get; set;}
        public String glCodeNumber {get; private set;}
        public String costCodeNumber {get; private set;}
        public String poKey {get; private set;}
        public List<String> RecordData {get; set;}
        public Set<String> livSet {get;set;}

        public ImportPOTicket(String pCsvLine,                             
                              Set<String> pPONumberSet,
                              Set<String> pPOKeySet,
                              Set<String> pEWRNumberSet,
                              Set<String> pAFENumberSet,
                              Set<String> pGLCodeSet,
                              Set<String> pCostCodeSet,
                              Set<String> pVendorIdSet,
                              Set<String> pLiIdSet,
                              Set<String> pDuplLiCheck,
                              Set<String> pPOKeyDuplCheck,
                              Set<String> pLiSet
                              ){

        SPCC_Purchase_Order__c poObj = new SPCC_Purchase_Order__c();
        SPCC_Vendor_Account_Assignment__c vaaObj = new SPCC_Vendor_Account_Assignment__c();
        SPCC_Cost_Element__c costElementObj = new SPCC_Cost_Element__c();
        SPCC_Line_Item__c liObj = new SPCC_Line_Item__c();
        
        this.livSet = pLiSet;
        this.po = poObj;
        this.vaa = vaaObj;
        this.costElement = costElementObj;
        this.lineItem = liObj;
        this.isError = false;
        this.isWarning = false;
        this.isInfo = false;
        this.miscGL = false;
        this.existingPO = false;
        this.errorMessage = '';
        this.requiredFieldsMissing = '';
        this.poId = '';
        this.poKey = '';
        this.rowNum = 1;
        
        List<String> csvRecordData = handleDoubleQuotes(pCsvLine);
        this.RecordData = csvRecordData;
        
        //perform validations, create sets, keys for POs and setting properties
        if(csvRecordData.size() > 0){
            try{
                String poNumber = GetStringValue(csvRecordData,COLUMN_INDEX_PO_NUMBER);
                String liNumber = GetStringValue(csvRecordData,COLUMN_INDEX_LI_NUMBER); 
                
                if (poNumber==null || poNumber==''){
                    this.isError = true;
                    this.errorMessage+= 'PO Number is required. ' + '<br/>';
                    this.requiredFieldsMissing += 'ponumber_';                  
                }
                 
                if (poNumber.length() < 10){
                        
                    while (poNumber.length() < 10){
                        
                        poNumber = '0' + poNumber;
                    }  
                    
                    this.poName = poNumber;
                    poObj.Purchase_Order_Number__c = poNumber;
                    pPONumberSet.add(poNumber);
                }
                    
                else{
                    
                    this.poName = poNumber;
                    poObj.Purchase_Order_Number__c = poNumber;
                    pPONumberSet.add(poNumber);
                }
                
                if(liNumber <> null && liNumber <> ''){ 
                    
                    if (liNumber.length() < 4){
                        
                        while (liNumber.length() < 4){
                        
                            liNumber = '0' + liNumber;
                        }
                    }     
                        
                    if (!this.livSet.isEmpty() && this.livSet.contains(liNumber)){
                    
                        liObj.Item__c = liNumber;
                        pLiIdSet.add(poNumber + '-' + liNumber);
                    }
                        
                    else {
                         this.isError = true;
                         this.errorMessage+= 'Line Item value does not match line item picklist value in salesforce. ' + '<br/>';
                    }
                }
                else{

                    this.isError = true;
                    this.errorMessage+= 'Line Item Number is required. ' + '<br/>';
                    this.requiredFieldsMissing += 'liNumber_';                         

                }

                String ewrNumber = GetStringValue(csvRecordData,COLUMN_INDEX_EWR); 
                if(ewrNumber==null || ewrNumber=='') {
                    this.isError = true;
                    this.errorMessage+= 'EWR is required. ' + '<br/>';  
                    this.requiredFieldsMissing += 'ewrnumber_';           
                }
                else {
                    pEWRNumberSet.add(ewrNumber);
                }


                String afeNumber = GetStringValue(csvRecordData,COLUMN_INDEX_AFE);
                afeNumber = afeNumber.toUpperCase();
                
                if(afeNumber==null || afeNumber=='') {
                    
                    this.isError = true;
                    this.errorMessage+= 'AFE is required. ' + '<br/>';
                    this.requiredFieldsMissing += 'afenumber_';             
                }
                else {
                    pAFENumberSet.add(afeNumber);
                }


                String glCode = GetStringValue(csvRecordData,COLUMN_INDEX_GL_CODE); 
                String costCode = GetStringValue(csvRecordData,COLUMN_INDEX_COST_CODE); 
                if((glCode==null || glCode=='') && (costCode==null || costCode=='')){
                    
                    this.isError = true;
                    this.errorMessage+= 'Either GL Code or Cost Code is required' + '<br/>';
                    this.requiredFieldsMissing += 'glandcc_';             
                }
                else if ((glCode<>null || glCode<>'') && (costCode==null || costCode=='')) {
                    
                    pGLCodeSet.add(glCode + '-' + afeNumber);                 
                    this.glCodeNumber = glCode;
                    this.requiredFieldsMissing += '_cc_'; 
                }
                else if ((glCode==null || glCode=='') && (costCode<>null || costCode<>'')) {
                    
                    pCostCodeSet.add(costCode + '-' + glCode + '-' + afeNumber);
                    this.costCodeNumber = costCode;
                    this.requiredFieldsMissing += '_gl_';
                    //will be removed once cost codes are in system
                    //this.isError = true;
                    this.errorMessage+= 'Cost codes are not in the system yet. Please enter GL Code.' + '<br/>';
                    this.isWarning = true;
                    this.isError = true; 
                }
                else {
                    pGLCodeSet.add(glCode + '-' + afeNumber);  
                    pCostCodeSet.add(costCode + '-' + glCode + '-' + afeNumber);
                    this.glCodeNumber = glCode;
                    this.costCodeNumber = costCode;
                    //will be removed once cost codes are in system
                    //this.isError = true;
                    this.errorMessage+= 'Cost codes are not in the system yet. ' + '<br/>';
                    this.isWarning = true; 
                }

                String vendorNumber = GetStringValue(csvRecordData,COLUMN_INDEX_VENDOR_ID); 
  
                if(vendorNumber==null || vendorNumber=='') {
                    
                    this.isError = true;
                    this.errorMessage+= 'Vendor ID is required' + '<br/>';
                    this.requiredFieldsMissing += 'vendor_';             
                }
                else {
                    
                    pVendorIdSet.add(vendorNumber);
                    this.VendorId = vendorNumber;
                }

    
                Decimal liValue = GetDecimalValue(csvRecordData,COLUMN_INDEX_LI_VALUE);
                if(liValue <> null){ 
                    
                    if (liValue < 0){
                        
                        this.isError = true;
                        this.errorMessage+= 'Line Item Value can not be negative. ' + '<br/>';
                    }
                    
                    else {
                    
                        liObj.Committed_Amount__c = liValue;
                    }
                } 
                else{

                    this.isError = true;
                    this.errorMessage+= 'Line Item Value is required. ' + '<br/>';
                    this.requiredFieldsMissing += 'liValue_';                         

                }
                
                String liShortText = GetStringValue(csvRecordData,COLUMN_INDEX_LI_SHORT_TEXT); 
                if (liShortText <> null && liShortText <> ''){ 
                    
                    if (liShortText.startsWith('"') && liShortText.endsWith('"')) {
        		        liObj.Short_Text__c = liShortText.removeStart('"').removeEnd('"');
    		        }
    		        
    		        else{
    		            liObj.Short_Text__c = liShortText;
    		        }
                } 
                
                else{
                    this.isError = true;
                    this.errorMessage+= 'Line Item Short Text is required. ' + '<br/>';
                    this.requiredFieldsMissing += 'liShortText';                         
                }

                String des = GetStringValue(csvRecordData,COLUMN_INDEX_DESCRITPION);
                if(des <> null && des <> '' ) {
                    if (des.startsWith('"') && des.endsWith('"')) {
        		        poObj.Description__c = des.removeStart('"').removeEnd('"');
    		        }
    		        else{
    		            poObj.Description__c = des;
    		        }
                }
                
                //build keys for PO to be imported and chek for duplicate PO entries in import file based on this key concatenated with LI Number
                if ((poNumber <> null && poNumber <> '') && (ewrNumber <> null && ewrNumber <> '') && (afeNumber <> null && afeNumber <> '') && (vendorNumber <> null && vendorNumber <> '') && (liNumber <> null && liNumber <> '')){
                    
                    if (!pDuplLiCheck.add(poNumber + '-' + liNumber)){
                        this.isError = true;
                        this.errorMessage += 'Line Item for this PO is already presented in import file. ' + '<br/>'; 
                    }
                    
                    else {
                        
                        pDuplLiCheck.add(poNumber + '-' + liNumber);
                    }
                    
                    if(!pPOKeyDuplCheck.add(poNumber + '-' + liNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorNumber)){
                        this.isError = true;
                        this.errorMessage += 'PO with the same LI Number, EWR Number, AFE Number and Vendor ID is already presented in import file. ' + '<br/>';
                    }
                    
                    else {
                        pPOKeyDuplCheck.add(poNumber + '-' + liNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorNumber);
                        pPOKeySet.add(poNumber + '-' + ewrNumber + '-' + afeNumber + '-' + vendorNumber);
                        this.poKey = poNumber + '-' +  ewrNumber + '-' + afeNumber;
                    }
                }
                else {
                    this.isError = true;
                    this.errorMessage += 'Some of the key fields are missing. ' + '<br/>'; //
                }
    
            }
            catch(Exception ex)
            {
                this.isError = true;
                this.errorMessage = ex.getMessage() + ' ' + ex.getLineNumber() + '<br/>';
            }
        }
    }
  }
}